# Completion

* AccessClient -> implemented in the client
* offline/examples test -> has offline tests based on examples in the API reference pdf
* live test -> is used in a test that runs against a real instance

| Section/Endpoint                                           | AccessClient       | offline/examples test | live test          |
|------------------------------------------------------------|--------------------|-----------------------|--------------------|
| 3. User                                                    | :white_check_mark: | :white_check_mark:    |                    |
| └─ 3.2 User Registration                                   | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 3.3 Update User                                         | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 3.4 Fetch User                                          | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 3.5 Fetch All Users                                     | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 3.6 Assign Access Policy to User                        | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 3.7 Assign NFC Card to User                             | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 3.8 Unassign NFC Card from User                         | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 3.9 Assign PIN Code to User                             | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 3.10 Unassign PIN Code from User                        | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 3.11 Create User Group                                  | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 3.12 Fetch All User Groups                              | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 3.13 Fetch User Group                                   | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 3.14 Update User Group                                  | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 3.15 Delete User Group                                  | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 3.16 Assign User to User Group                          | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 3.17 Unassign User from User Group                      | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 3.18 Fetch Users in a User Group                        | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 3.19 Fetch All Users in a User Group                    | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 3.20 Fetch the Access Policies Assigned to a User       | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 3.21 Assign Access Policy to User Group                 | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 3.22 Fetch the Access Policies Assigned to a User Group | :white_check_mark: | :white_check_mark:    | :x:                |
| 4. Visitor                                                 | :white_check_mark: | :white_check_mark:    |                    |
| └─ 4.2 Create Visitor                                      | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 4.3 Fetch Visitor                                       | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 4.4 Fetch All Visitors                                  | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 4.5 Update Visitor                                      | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 4.6 Delete Visitor                                      | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 4.7 Assign NFC Card To Visitor                          | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 4.8 Unassign NFC Card From Visitor                      | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 4.9 Assign PIN Code To Visitor                          | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 4.10 Unassign PIN Code From Visitor                     | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| 5.  Access Policy                                          | :white_check_mark: | :white_check_mark:    |                    |
| └─ 5.2 Create Access Policy                                | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 5.3 Update Access Policy                                | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 5.4 Delete Access Policy                                | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 5.5 Fetch Access Policy                                 | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 5.6 Fetch All Access Policies                           | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 5.8 Create Holiday Group                                | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 5.9 Update Holiday Group                                | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 5.10 Delete Holiday Group                               | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 5.11 Fetch Holiday Group                                | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 5.12 Fetch All Holiday Groups                           | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 5.14 Create Schedule                                    | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| └─ 5.15 Update Schedule                                    | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 5.16 Fetch Schedule                                     | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 5.17 Fetch All Schedules                                | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 5.18 Delete Schedule                                    | :white_check_mark: | :white_check_mark:    | :white_check_mark: |
| 6. Credential                                              | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 6.1 Generate PIN Code                                   | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 6.2 Enroll NFC Card                                     | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 6.3 Fetch NFC Card Enrollment Status                    | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 6.4 Remove a Session Created for NFC Card Enrollment    | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 6.7 Fetch NFC Card                                      | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 6.8 Fetch All NFC Cards                                 | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 6.9 Delete NFC Card                                     | :white_check_mark: | :white_check_mark:    | :x:                |
| 7. Space                                                   | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.1 Fetch Door Group Topology                           | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.2 Create Door Group                                   | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.3 Fetch Door Group                                    | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.4 Update Door Group                                   | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.5 Fetch All Door Groups                               | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.6 Delete Door Group                                   | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.7 Fetch Door                                          | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.8 Fetch All Doors                                     | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.9 Remote Door Unlocking                               | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.10 Set Temporary Door Locking Rule                    | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.11 Fetch Door Locking Rule                            | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.12 Set Door Emergency Status                          | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 7.13 Fetch Door Emergency Status                        | :white_check_mark: | :white_check_mark:    | :x:                |
| 8. Device                                                  | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 8.1 Fetch Devices                                       | :white_check_mark: | :white_check_mark:    | :x:                |
| 9. System Log                                              | :white_check_mark: |                       | :x:                |
| └─ 9.2 Fetch System Logs                                   | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 9.3 Export System Logs                                  | :x:                | :white_check_mark:    | :x:                |
| └─ 9.4 Fetch Resources in System Logs                      | :x:                | :x:                   | :x:                |
| └─ 9.5 Fetch Static Resources in System Logs               | :x:                | :x:                   | :x:                |
| 10. UniFi Identity                                         | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 10.1 Send UniFi Identity Invitations                    | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 10.2 Fetch Available Resources                          | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 10.3 Assign Resources to Users                          | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 10.4 Fetch Resources Assigned to Users                  | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 10.5 Assign Resources to User Groups                    | :white_check_mark: | :white_check_mark:    | :x:                |
| └─ 10.6 Fetch the Resources Assigned to User Groups        | :white_check_mark: | :white_check_mark:    | :x:                |
| 11. Notification                                           | :x:                | :x:                   | :x:                |
| └─ 11.1 Fetch Notifications [WebSocket]                    | :x:                | :x:                   | :x:                |
| └─ 11.2 List of Supported Webhook Events [Webhook]         | :x:                | :x:                   | :x:                |
| └─ 11.3 Fetch Webhook Endpoints List [Webhook]             | :x:                | :x:                   | :x:                |
| └─ 11.4 Add Webhook Endpoints [Webhook]                    | :x:                | :x:                   | :x:                |
| └─ 11.5 Update Webhook Endpoints [Webhook]                 | :x:                | :x:                   | :x:                |
| └─ 11.6 Delete Webhook Endpoints [Webhook]                 | :x:                | :x:                   | :x:                |
| 12. API Server                                             | :x:                | :x:                   | :x:                |
| └─ 12.1 Upload HTTPS Certificate                           | :x:                | :x:                   | :x:                |
| └─ 12.2 Delete HTTPS Certificate                           | :x:                | :x:                   | :x:                |
