from enum import StrEnum
from typing import Any

from ._base import ForbidExtraBaseModel, IdentityResourceId, UserId


class IdentityInvitationUser(ForbidExtraBaseModel):
    user_id: UserId
    email: str | None = None


class IdentityInvitationEmailFailure(ForbidExtraBaseModel):
    error_code: str
    error_msg: str
    user_email: str
    user_id: UserId


class IdentityResourceType(StrEnum):
    EV_STATION = "ev_station"
    VPN = "vpn"
    WIFI = "wifi"


class IdentityResource(ForbidExtraBaseModel):
    id: IdentityResourceId
    """Identity ID of the resources."""
    name: str
    """Name of the resources."""
    deleted: bool
    """Indicate whether the resource is disabled."""
    short_name: str
    """!!! note "not listed in API docs" """
    # XXX: narrower type
    metadata: Any | None
    """!!! note "not listed in API docs" """
